#include <bits/stdc++.h>
#include <stdlib.h>
#define MAX 100
using namespace std;

int napravi(int niz[], int uzorak[], int vel, int broj)
{
    int pom = 0;
    for(int i=0; i < vel; i++)
    {
        if(niz[i] == broj)
        {
            uzorak[i] = broj;
            pom = 1;
        }
        else
            uzorak[i] = 0;
    }
    return pom;
}

int poredi(int kontrola[], int uzorak[], int vel, int broj)
{
    int pom = 0;
    for(int i=0; i < vel; i++)
        if(kontrola[i] != uzorak[i])
            pom = 1;

    return pom;
}

int nema(int niz[], int vel, int broj)
{
    int pom = 0;

    for(int i=0; i < vel; i++)
        if(niz[i] == broj)
            pom = 1;

    return pom;
}

int main()
{
    int matrica[MAX][MAX], kontrola[MAX], uzorak[MAX], x=0, vrs, vel, mod, pom;

    scanf("%d %d", &vel, &vrs);

    for(int i=0; i < vel; i++)
        for(int j=0; j < vel; j++)
            scanf("%d", &matrica[i][j]);

    for(int br=1; br <= vrs; br++)
    {
        mod = 1;
        for(int i=0; i < vel; i++)
        {
            if(mod == 1)
            {
                pom = napravi(matrica[i], kontrola, vel, br);

                if(vel == i + 1 && pom == 1)
                    x++;
                else if(pom == 1)
                    mod = 2;
            }
            else if(mod == 2)
            {
                pom = napravi(matrica[i], uzorak, vel, br);

                if(pom == 0)
                {
                    if(i == vel-1)
                        x++;
                    else
                        mod = 3;
                }
                else
                {
                    pom = poredi(kontrola, uzorak, vel, br);

                    if(pom == 1)
                        break;
                    else if(i == vel-1)
                        x++;
                }
            }
            else if(mod == 3)
            {
                pom = nema(matrica[i], vel, br);

                if(pom == 1)
                    break;
                else if(i == vel-1)
                    x++;
            }
        }
    }

    printf("%d", x);


    return 0;
}